open Term
open Subst

let rec rewrite_root1 t = function
  | [] -> false, t
  | (l, r) :: rules ->
      try
	true, substitute (pattern_match l t) r
      with
	Not_matched -> rewrite_root1 t rules

let rec rewrite1_aux rules = function
  | V _ as t -> false, t
  | F (f, ts) ->
      let l = [ rewrite1_aux rules ti | ti <- ts ] in
      let b, u = rewrite_root1 (F (f, [ t | _, t <- l ])) rules in
      b || List.exists (fun (b, _) -> b) l, u

let rec nf rules t =
  let b, u = rewrite1_aux rules t in
  if b then nf rules u else t


let rec rewrite_root rules s = 
  Listx.unique
    [ substitute (pattern_match l s) r 
    | (l, r) <- rules; is_instance_of s l ]

let rewrite rules s =
  Listx.unique
    [ replace s t p 
    | p <- positions s; 
      t <- rewrite_root rules (subterm_at p s) ]

let rec rewrite_parallel rules = function
  | V x as s -> [s]
  | F (f, ts) as s -> 
      let l = [ rewrite_parallel rules si | si <- ts ] in
      Listset.union (rewrite_root rules s) [ F (f, ts) | ts <- Listx.pi l ]
